#ifndef _OBJECT_H
#define _OBJECT_H

#include "mat_vect.h"

#define MAX_VERTICES 10000
#define MAX_POLYGONS 10000


typedef struct{
    float x,y,z;
}vertex_type;

typedef struct{
    int a,b,c;
}polygon_type;

typedef struct{
    float u,v;
}mapcoord_type;

typedef struct {

	char name[20];
    
	int vertices_qty;
    int polygons_qty;

    vertex_type vertex[MAX_VERTICES];
    vertex_type normal[MAX_VERTICES];
    polygon_type polygon[MAX_POLYGONS];
    mapcoord_type mapcoord[MAX_VERTICES];

    int id_texture;

} obj_type, *obj_type_ptr;


extern obj_type object;

extern char ObjLoad(char *p_object_name, char *p_texture_name);
extern void ObjCalcNormals(obj_type_ptr p_object);

#endif
